package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.UserCollectionService;
import com.gxwebsoft.shop.entity.UserCollection;
import com.gxwebsoft.shop.param.UserCollectionParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 我的收藏控制器
 *
 * @author 科技小王子
 * @since 2024-04-28 18:17:37
 */
@Api(tags = "我的收藏管理")
@RestController
@RequestMapping("/api/shop/user-collection")
public class UserCollectionController extends BaseController {
    @Resource
    private UserCollectionService userCollectionService;

    @ApiOperation("分页查询我的收藏")
    @GetMapping("/page")
    public ApiResult<PageResult<UserCollection>> page(UserCollectionParam param) {
        // 使用关联查询
        return success(userCollectionService.pageRel(param));
    }

    @ApiOperation("查询全部我的收藏")
    @GetMapping()
    public ApiResult<List<UserCollection>> list(UserCollectionParam param) {
        // 使用关联查询
        return success(userCollectionService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userCollection:list')")
    @ApiOperation("根据id查询我的收藏")
    @GetMapping("/{id}")
    public ApiResult<UserCollection> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userCollectionService.getByIdRel(id));
    }

    @ApiOperation("添加我的收藏")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserCollection userCollection) {
        // 记录当前登录用户id
        // User loginUser = getLoginUser();
        // if (loginUser != null) {
        //  userCollection.setUserId(loginUser.getUserId());
        // }
        if (userCollectionService.save(userCollection)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改我的收藏")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserCollection userCollection) {
        if (userCollectionService.updateById(userCollection)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除我的收藏")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userCollectionService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加我的收藏")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserCollection> list) {
        if (userCollectionService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改我的收藏")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserCollection> batchParam) {
        if (batchParam.update(userCollectionService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除我的收藏")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userCollectionService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
